<template>
  <div
    class="profile_resources card"
    :class="{disabled: disableCard}">
    <div class="profile_resources-header">
      <div class="profile_resources-header-title">
        {{$t('profile.eosResources')}}
      </div>
      <div class="profile_resources-header-func">
        <v-popover
          offset="16"
          placement="left">
          <img
            class="profile-info"
            src="~/static/icons/information.png"
            alt="">
          <template slot="popover">
            {{$t('helpers.resources')}}
          </template>
        </v-popover>
      </div>
    </div>
    <div class="profile_resources-inner">
      <div
        class="profile_resources-body">
        <div class="profile_resources-type">
          <div class="profile_resources-type-name profile_resources-type-ram">
            {{$t('profile.ram')}}
          </div>
          <div class="profile_resources-type-progress">
            <div class="profile_resources-type-progress-stacked">
              <span>{{$t('profile.reserve')}}</span>
              <span class="color-white">{{isDemo ? '∞' :resources.ram.eos}} EOS</span>
            </div>
            <ProgressBar
              :value="isDemo ? '100%' : percentage.ram+'%'"
              type="green"></ProgressBar>
            <div class="profile_resources-type-progress-bets flex flex-between">
              <div>{{!isDemo ? (parseInt(percentage.ram)+'%') : ''}}</div>
              <div>{{!isDemo ? (parseInt(resources.ram.max / 1024 * 100) / 100 +' KB') : ''}}</div>
            </div>
          </div>
        </div>
        <div class="profile_resources-type">
          <div class="profile_resources-type-name profile_resources-type-cpu">
            {{$t('profile.cpu')}}
          </div>
          <div class="profile_resources-type-progress">
            <div class="profile_resources-type-progress-stacked">
              <span>{{$t('profile.rent')}}</span>
              <span class="color-white">{{isDemo ? '∞' : resources.cpu.eos}} EOS</span>
            </div>
            <ProgressBar
              :value="isDemo ? '100%' : percentage.cpu+'%'"
              type="deepOrange"></ProgressBar>
            <div class="profile_resources-type-progress-bets flex flex-between">
              <div>{{!isDemo ? (parseInt(percentage.cpu)+'%') : ''}}</div>
              <div>{{!isDemo ? (parseInt(resources.cpu.max * 100) / 100 +' µs') : ''}}</div>
            </div>
          </div>
        </div>
        <div class="profile_resources-type">
          <div class="profile_resources-type-name profile_resources-type-net">
            {{$t('profile.net')}}
          </div>
          <div class="profile_resources-type-progress">
            <div class="profile_resources-type-progress-stacked">
              <span>{{$t('profile.rent')}}</span>
              <span class="color-white">{{isDemo ? '∞' : resources.net.eos}} EOS</span>
            </div>
            <ProgressBar
              :value="isDemo ? '100%' : percentage.net+'%'"
              type="deepBlue"></ProgressBar>
            <div class="profile_resources-type-progress-bets flex flex-between">
              <div>{{!isDemo ? (parseInt(percentage.net)+'%') : ''}}</div>
              <div>{{!isDemo ? (parseInt(resources.net.max / 1024 * 100) / 100 +' KB') : ''}}</div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import ProgressBar from '~/components/UI/Progress';

  export default {
    name: "stats",
    data() {
      return {
        percentage: {
          ram: 0,
          cpu: 0,
          net: 0
        }
      }
    },
    components: {
      ProgressBar
    },
    computed: {
      disableCard() {
        return this.$store.state.wallet.accountName === 'No account';
      },
      isDemo() {
        return this.$store.state.common.demo;
      },
      resources() {
        const resources = this.$store.state.wallet.resources;
        this.percentage.ram = resources.ram.max === 0 ? 0 : (100 - (resources.ram.max < 0 ? 0 : resources.ram.used / resources.ram.max * 100));
        this.percentage.cpu = resources.cpu.max === 0 ? 0 : (100 - (resources.cpu.max < 0 ? 0 : resources.cpu.used / resources.cpu.max * 100));
        this.percentage.net = resources.net.max === 0 ? 0 : (100 - (resources.net.max < 0 ? 0 : resources.net.used / resources.net.max * 100));
        return resources;
      },
    },
    mounted() {
      !this.isDemo && this.$store.dispatch('wallet/checkRamPrice');
    }
  }
</script>
